<?php

use Bitrix\Main\Application;
use Bitrix\Main\Config\Option;
use Bitrix\Main\Loader;
use Bitrix\Main\Localization\Loc;
use Bitrix\Main\Text\HtmlFilter;

global $APPLICATION;
$module_id = 'angrycode.wappiregister';
defined('ADMIN_MODULE_NAME') or define('ADMIN_MODULE_NAME', 'angrycode.wappiregister');

if (!$USER->isAdmin()) {
  $APPLICATION->authForm('Nope');
}

$app = Application::getInstance();
$context = $app->getContext();
$request = $context->getRequest();

Loader::includeModule(ADMIN_MODULE_NAME);

Loc::loadMessages($context->getServer()->getDocumentRoot() . "/bitrix/modules/main/options.php");
Loc::loadMessages(__FILE__);


$tabControl = new CAdminTabControl("tabControl", array(
  array(
    "DIV" => "edit1",
    "TAB" => Loc::getMessage("MAIN_TAB_SET"),
    "TITLE" => Loc::getMessage("MAIN_TAB_TITLE_SET"),
  ),
));

if ((!empty($save) || !empty($restore)) && $request->isPost() && check_bitrix_sessid()) {
  if (!empty($restore)) {
    Option::delete(ADMIN_MODULE_NAME);
    CAdminMessage::showMessage(array(
      "MESSAGE" => Loc::getMessage("ANGRYCODE_WAPPIREGISTER_REFERENCES_OPTIONS_RESTORED"),
      "TYPE" => "OK",
    ));
  } elseif ($request->getPost('PROFILE_ID') && $request->getPost('TOKEN')) {

  


    Option::set(
      ADMIN_MODULE_NAME,
      "PROFILE_ID",
      $request->getPost('PROFILE_ID')
    );

    Option::set(
      ADMIN_MODULE_NAME,
      "TOKEN",
      $request->getPost('TOKEN')
    );

    CAdminMessage::showMessage(array(
      "MESSAGE" => Loc::getMessage("ANGRYCODE_WAPPIREGISTER_REFERENCES_OPTIONS_SAVED"),
      "TYPE" => "OK",
    ));
  } else {
    CAdminMessage::showMessage(Loc::getMessage("ANGRYCODE_WAPPIREGISTER_REFERENCES_INVALID_VALUE"));
  }
}


$loginOptions = Option::get(ADMIN_MODULE_NAME, "PROFILE_ID", '');
$passwordOptions = Option::get(ADMIN_MODULE_NAME, "TOKEN", '');
$allDataSave = false;
$connectedService = false;
$smscBalance = 0;
$error = array();

if (!empty($loginOptions) && !empty($passwordOptions)) {
  $allDataSave = true;
}

if ($allDataSave) {
  $WappiApiClass = new \Angrycode\WappiRegister\WappiApi($loginOptions, $passwordOptions);
  
  $getStatus = $WappiApiClass->getStatus();

  

  if ($getStatus->isSuccess()) {
    $wappiData = ($getStatus->getData());
    $connectedService = true;
  }
  
  if ($getStatus->getErrors()) {

    foreach ($getStatus->getErrorMessages() as $errorMessage) {
      $error[] = $errorMessage;
      ?><?
    }
  }

}


$tabControl->begin();
?>

<form method="post"
      action="<?= sprintf('%s?mid=%s&lang=%s', $request->getRequestedPage(), urlencode($mid), LANGUAGE_ID) ?>">
  <?php
  echo bitrix_sessid_post();
  $tabControl->beginNextTab();
  

  ?>
  <tr>
      <td></td>
      <td>
  <?
  foreach ($error as $er) {
    ?>
      <div style="background: red; color:#fff;padding: .2rem;margin-bottom: 1rem;border-radius: 4px;">
      <?=GetMessage("ANGRYCODE_WAPPIREGISTER_OSIBKA")?><?
    echo $er;
    ?></div><?
  }
  ?>
      </td>
  </tr>


  <? if ($connectedService): ?>
      <tr>
          <td><?=GetMessage("ANGRYCODE_WAPPIREGISTER_PROFILQ")?></td>
          <td><?=$wappiData['name']?></td>
      </tr>

      <tr>
          <td><?=GetMessage("ANGRYCODE_WAPPIREGISTER_STATUS")?></td>
          <td><?=$wappiData['app_status']?></td>
      </tr>

      <tr>
          <td><?=GetMessage("ANGRYCODE_WAPPIREGISTER_AVTORIZACIA")?></td>
          <td><?=$wappiData['authorized'] ? GetMessage("ANGRYCODE_WAPPIREGISTER_DA") : GetMessage("ANGRYCODE_WAPPIREGISTER_NET")?></td>
      </tr>

      <tr>
          <td><?=GetMessage("ANGRYCODE_WAPPIREGISTER_NOMER_TELEFONA")?></td>
          <td><?=$wappiData['phone']?></td>
      </tr>
  <? else: ?>
      <tr>
          <td>&nbsp;</td>
          <td>
            <?= Loc::getMessage('ANGRYCODE_WAPPIREGISTER_OPTIONS_DESC_REGISTRATION') ?>

          </td>
      </tr>
  <? endif; ?>

    

    <tr>
        <td width="40%">
            <label for="login"><?= Loc::getMessage("ANGRYCODE_WAPPIREGISTER_REFERENCES_LOGIN") ?>:</label>
        <td width="60%">
            <input type="text"
                   size="50"
                   name="PROFILE_ID"
                   value="<?= HtmlFilter::encode($loginOptions); ?>"
            />
        </td>
    </tr>

    <tr>
        <td width="40%">
            <label for="password"><?= Loc::getMessage("ANGRYCODE_WAPPIREGISTER_REFERENCES_PASSWORD") ?>:</label>
        <td width="60%">
            <input type="text"
                   size="50"
                   name="TOKEN"
                   value="<?= HtmlFilter::encode($passwordOptions); ?>"
            />
        </td>
    </tr>

  <?php
  $tabControl->buttons();
  ?>
    <input type="submit"
           name="save"
           value="<?= Loc::getMessage("MAIN_SAVE") ?>"
           title="<?= Loc::getMessage("MAIN_OPT_SAVE_TITLE") ?>"
           class="adm-btn-save"
    />
    <input type="submit"
           name="restore"
           title="<?= Loc::getMessage("MAIN_HINT_RESTORE_DEFAULTS") ?>"
           onclick="return confirm('<?= AddSlashes(GetMessage("MAIN_HINT_RESTORE_DEFAULTS_WARNING")) ?>')"
           value="<?= Loc::getMessage("MAIN_RESTORE_DEFAULTS") ?>"
    />
  <?php
  $tabControl->end();
  ?>
</form>
